;--------------------------------------;
;                                      ;
;  ZAVADEC pro PIC16F876 a PIC16F877   ;
;   posledni upravy dne: 24.8.2004     ;
;                                      ;
;--------------------------------------;

	LIST	P = 16F877, R = HEX
	include	p16f877.inc

	__CONFIG	H'3F7A'


;--------------------------------------

OffRam	EQU	0x20		; POCATECNI PAMET
DATA_	EQU	OffRam		; POMOCNE REGISTRY
STAV	EQU	OffRam + 1
HODN	EQU	OffRam + 2

;--------------------------------------
	ORG	0
	MOVLW	B'00011110' ; skok na zavadec
	MOVWF	PCLATH	  ; je zapotrebi nastavit PCLATH (nejvissi blok prog. pameti)
	GOTO	START	  ; skok na zavadec (v ramci nejvyssiho bloku prog. pameti)

;--------------------------------------

MAIN	GOTO	MAIN	  ; zde zacina uzivatelsky program (adresa 0003h)

;--------------------------------------

	ORG	H'1E00'	; zde zacina zavadec!!!

	CLRF	PCLATH	; toto je ochrana pred chybnym uzivatelskym programem
	GOTO	MAIN	; pokud se uzivatelsky program dostane omylem az sem,
			; tak je poslan zpet na adresu 0003h

ZPRACUJ	MOVF	STAV,F	; rozcesti elementarnich ukolu
	BTFSC	STATUS,Z	; Pokud je STAV nulovy,
	GOTO	Z_VYBER	; ocekava se volba prikazu...
	DECF	STAV,F	; Pokud je STAV nenulovy,
	BTFSC	STATUS,Z	; provede se elementarni krok nektereho prikazu:
	GOTO	Z_W1	; zapis do FLASH (STAV = 1,2,3,4,5)
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_W2
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_W3
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_W4
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_W5
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_R1	; cteni z FLASH (STAV = 6,7,8,9)
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_R2
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_R3
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_R4
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_EW1	; zapis do EEPROM (STAV = 10,11,12)
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_EW2
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_EW3
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_ER1	; cteni z EEPROM (SATV = 13,14)
	DECF	STAV,F
	BTFSC	STATUS,Z
	GOTO	Z_ER2
	CLRF	STAV
	RETURN

		; Vyber prikazu:
Z_VYBER	MOVLW	D'87'	; Zapis do FLASH = "W"
	XORWF	HODN,F
	BTFSC	STATUS,Z
	GOTO	STAV_W
	MOVLW	D'5'	; Cteni z FLASH = "R"
	XORWF	HODN,F
	BTFSC	STATUS,Z
	GOTO	STAV_R
	MOVLW	D'3'	; Ukonceni zavadece = "Q"
	XORWF	HODN,F
	BTFSC	STATUS,Z
	GOTO	STAV_Q
	MOVLW	D'20'	; Zapis do EEPROM = "E"
	XORWF	HODN,F
	BTFSC	STATUS,Z
	GOTO	STAV_EW
	MOVLW	D'32'	; Cteni z EEPROM = "e"
	XORWF	HODN,F
	BTFSC	STATUS,Z
	GOTO	STAV_ER
	RETURN
		; Nastaveni promenne STAV podle prikazu	
STAV_W	MOVLW	D'1'	; zacatek zapisu do FLASH
	MOVWF	STAV
	RETURN
STAV_R	MOVLW	D'6'	; zacatek cteni z FLASH
	MOVWF	STAV
	RETURN
STAV_EW	MOVLW	D'10'	; zacatak zapisu do EEPROM
	MOVWF	STAV
	RETURN
STAV_ER	MOVLW	D'13'	; zacatek ceteni z EEPROM
	MOVWF	STAV
	RETURN
STAV_Q	MOVLW	D'255'	; 255 znamena konec zavadece
	MOVWF	STAV
	RETURN

Z_W1	MOVF	HODN,W	; nastaveni nizsiho bytu FLASH adresy
	BSF	STATUS,RP1
	MOVWF	EEADR
	BCF	STATUS,RP1
	MOVLW	D'2'
	MOVWF	STAV
	RETURN
Z_W2	MOVF	HODN,W	; nastaveni vyssiho bytu FLASH adresy
	BSF	STATUS,RP1
	ANDLW	B'00011111'
	MOVWF	EEADRH
	BCF	STATUS,RP1
	MOVLW	D'3'
	MOVWF	STAV
	RETURN
Z_W3	MOVF	HODN,W	; nastaveni nizsiho bytu slova (pro FLASH)
	BSF	STATUS,RP1
	MOVWF	EEDATA
	BCF	STATUS,RP1
	MOVLW	D'4'
	MOVWF	STAV
	RETURN
Z_W4	MOVF	HODN,W	; nastaveni vyssiho bytu slova (pro FLASH)
	BSF	STATUS,RP1
	MOVWF	EEDATH
	BCF	STATUS,RP1
	MOVLW	D'5'
	MOVWF	STAV
	RETURN
Z_W5	MOVF	HODN,W	; povel k zapisu do FLASH
	XORLW	D'71'
	MOVWF	HODN
	BTFSC	STATUS,Z
	CALL	FLASHW
	CLRF	STAV	; interpret prikazu je vyresetovan
	RETURN

Z_R1	MOVF	HODN,W	; nastaveni nizsiho bytu FLASH adresy
	BSF	STATUS,RP1
	MOVWF	EEADR
	BCF	STATUS,RP1
	MOVLW	D'7'
	MOVWF	STAV
	RETURN
Z_R2	MOVF	HODN,W	; nastaveni vyssiho bytu FLASH adresy
	BSF	STATUS,RP1
	ANDLW	B'00011111'
	MOVWF	EEADRH
	BCF	STATUS,RP1
	MOVLW	D'8'
	MOVWF	STAV
	RETURN
Z_R3	MOVF	HODN,W	; prikaz ke cteni z FLASH a vyslani nizsiho bytu
	XORLW	D'71'
	BTFSC	STATUS,Z
	GOTO	Z_RG1
	CLRF	STAV	; pokud je prikaz nespravny,
	CLRF	HODN	; interpret prikazu se vyresetuje
	RETURN
Z_RG1	CALL	FLASHR	; je precten obsah FLASH (2 byty)
	BSF	STATUS,RP1
	MOVF	EEDATA,W
	BCF	STATUS,RP1
	MOVWF	HODN	; nizsi byte je zapsan do HODN
	MOVLW	D'9'
	MOVWF	STAV
	RETURN
Z_R4	MOVF	HODN,W	; prikaz k vyslani vyssiho bytu (z FLASH)
	XORLW	D'71'
	BTFSC	STATUS,Z
	GOTO	Z_RG2
	CLRF	STAV	; pokud je prikaz nespravny,
	CLRF	HODN	; interpret prikazu se vyresetuje
	RETURN
Z_RG2	BSF	STATUS,RP1
	MOVF	EEDATH,W
	BCF	STATUS,RP1
	MOVWF	HODN	; vyssi byte je zapsan do HODN
	CLRF	STAV	; interpret prikazu je vyresetovan
	RETURN

Z_EW1	MOVF	HODN,W	; nastaveni adresy EEPROM
	BSF	STATUS,RP1
	MOVWF	EEADR
	BCF	STATUS,RP1
	MOVLW	D'11'
	MOVWF	STAV
	RETURN
Z_EW2	MOVF	HODN,W	; nastaveni bytu pro zapis do EEPROM
	BSF	STATUS,RP1
	MOVWF	EEDATA
	BCF	STATUS,RP1
	MOVLW	D'12'
	MOVWF	STAV
	RETURN
Z_EW3	MOVF	HODN,W	; povel k zahajeni zapisu do EEPROM
	XORLW	D'71'
	MOVWF	HODN
	BTFSC	STATUS,Z
	CALL	EEW
	CLRF	STAV	; interpret prikazu je vyresetovan
	RETURN

Z_ER1	MOVF	HODN,W	; nastaveni adresy EEPROM
	BSF	STATUS,RP1
	MOVWF	EEADR
	BCF	STATUS,RP1
	MOVLW	D'14'
	MOVWF	STAV
	RETURN
Z_ER2	MOVF	HODN,W	; povel k precteni EEPROM a vyslani bytu
	XORLW	D'71'
	MOVWF	HODN
	BTFSC	STATUS,Z
	GOTO	Z_EG	; pokud je povel nespravny,
	CLRF	STAV	; interpret prikazu se vyresetuje
	RETURN
Z_EG	CALL	EER	; precteni bytu z EEPROM
	BSF	STATUS,RP1
	MOVF	EEDATA,W
	BCF	STATUS,RP1
	MOVWF	HODN	; zapis do HODN
	CLRF	STAV	; vyresetovani interpretu prikazu
	RETURN

	; ZDE ZACINA ZAVADEC
START	BSF	STATUS,RP0	; nastaveni casovace TMR0
	MOVLW	B'11010100'
	MOVWF	OPTION_REG
	BCF	STATUS,RP0
	MOVLW	B'00101001'	; nastaveni casovace TMR1
	MOVWF	T1CON
	CLRF	TMR1L
	MOVLW	D'128'
	MOVWF	TMR1H
	BCF	PIR1,TMR1IF

	CLRF	DATA_		; inicializace promennych
	CLRF	STAV

SETSPEED	BTFSC	PORTC,7		; ceka se, az prejde RC7 do jednicky...
	GOTO	$ + 4
	BTFSC	PIR1,TMR1IF
	GOTO	ZAV_KONEC		; ...pokud tak neucini "vcas", zavadec konci
	GOTO	$ - 4
SETS_J0	BTFSS	PORTC,7		; nyni se ceka, az prejde RC7 do nuly
	GOTO	$ + 4
	BTFSC	PIR1,TMR1IF
	GOTO	ZAV_KONEC		; ...pokud tak neucini "vcas", zavadec konci
	GOTO	$ - 4
	CLRF	TMR0		; jakmile prejde RC7 do nuly, resetuje se casovac TMR0
	BCF	INTCON,T0IF
	CLRF	TMR1L		; resetuje se i TMR1
	CLRF	TMR1H
	BCF	PIR1,TMR1IF
	BTFSC	PORTC,7		; ceka se, az prejde RC7 do jednicky
	GOTO	$ + 4
	BTFSC	PIR1,TMR1IF
	GOTO	ZAV_KONEC		; ...pokud tak neucini "vcas", zavadec konci
	GOTO	$ - 4
	MOVLW	D'4'		; casova kompenzace (nastaveno metodou pokus/omyl)
	MOVWF	HODN
	DECFSZ	HODN,F
	GOTO	$ - 1
	NOP
	NOP
	DECF	TMR0,W		; zmereni casoveho useku (musi se o jednicku snizit)
	BTFSC	INTCON,T0IF	;  pokud doslo k preteceni TMR0,
	GOTO	ZAV_KONEC		;  zavadec konci
	BSF	STATUS,RP0
	MOVWF	SPBRG		; pomoci udaje v TMR0 je nastavena hardwarova komunikacni rychlost
	BCF	STATUS,RP0
	BSF	RCSTA,SPEN	; je nastaven hardwarovy seriovy port
	
	CLRF	TMR1L		; vyresetovani TMR1
	CLRF	TMR1H
	BCF	PIR1,TMR1IF
	MOVLW	B'10010000'
	MOVWF	RCSTA
	BSF	STATUS,RP0
	MOVLW	B'00100110'
	MOVWF	TXSTA
	BCF	STATUS,RP0
BEGIN	BTFSC	PIR1,TMR1IF	; nyni se bude cekat na prichod znaku na port
	GOTO	ZAV_KONEC		; pokud tento znak dlouho neprijde, zavadec konci
	BTFSS	PIR1,RCIF
	GOTO	BEGIN
	BTFSS	RCSTA,FERR	; osetreni chyby ramce
	GOTO	$ + 3
	MOVF	RCREG,W
	GOTO	BEGIN
	MOVF	RCREG,W
	XORLW	D'128'
	BTFSS	STATUS,Z		; pokud se jedna o znak s cislem 128 (tedy 80h),
	GOTO	BEGIN		; potom je komunikace v poradku...

	; NYNI PROBIHA UZIVATELSKA KOMUNIKACE SE ZAVADECEM
	MOVLW	B'00011001'	; snizeni predelicky pro TMR1
	MOVWF	T1CON
BEGIN_	CLRF	TMR1L		; resetovani casovace TMR1
	CLRF	TMR1H
	BCF	PIR1,TMR1IF
	CLRF	STAV		; resetovani interpretu prikazu
LOOP	BTFSC	PIR1,TMR1IF
	GOTO	BEGIN_		; pokud TMR1 pretece, interpret prikazu a TMR1 musi byt resetovany
	BTFSS	PIR1,RCIF		; je prijmut novy znak?
	GOTO	LOOP
	BTFSS	RCSTA,FERR	; (osetreni chyby ramce)
	GOTO	$ + 3
	MOVF	RCREG,W
	GOTO	BEGIN_
	MOVF	RCREG,W		; precteni znaku
	MOVWF	HODN		; ulozeni znaku do HODN
	MOVF	STAV,W		; precteni stavu interpretu prikazu
	CALL	ZPRACUJ		; vola se interpret prikazu!!!
	MOVF	HODN,W		; hodnata HODN (pripadne upravena)...
	MOVWF	TXREG		; je vyslana na vystup portu
	CLRF	TMR1L		; casovac TMR1 je vyresetovan
	CLRF	TMR1H
	BCF	PIR1,TMR1IF
	MOVLW	B'11111111'
	XORWF	STAV,W
	BTFSC	STATUS,Z		; pokud je indikovan pozadavek ukonceni zavadece,
	GOTO	ZAV_KONEC + 2	; potom bude zavadec ukoncen
	GOTO	LOOP

	; ZDE PROBIHA ZAPIS DO FLASH PAMETI
FLASHW	BSF	STATUS,RP1	; nasledujici blok programu
	BCF	STATUS,RP0	; propusti pouze adresy,
	MOVF	EEADRH,W		; ktere jsou v rozsahu 0003h - 1DFFh
	ANDLW	B'00011110'
	XORLW	B'00011110'
	BTFSC	STATUS,Z
	GOTO	FLWROUT		; mimo rozsah (horni mez)
	MOVF	EEADRH,W
	ANDLW	B'00011111'
	BTFSS	STATUS,Z
	GOTO	FLASHWJ00
	MOVLW	D'3'
	SUBWF	EEADR,W
	BTFSS	STATUS,C
	GOTO	FLWROUT		; mimo rozsah (dolni mez)
	; ZAHAJUJE SE ZAPIS
FLASHWJ00	BSF	STATUS,RP0
	BSF	EECON1,EEPGD
	BSF	EECON1,WREN
	MOVLW	0x55
	MOVWF	EECON2
	MOVLW	0xAA
	MOVWF	EECON2
	BSF	EECON1,WR
	NOP
	NOP
	BCF	EECON1,WREN
	BCF	STATUS,RP0
FLWROUT	BCF	STATUS,RP1
	RETURN

	; ZDE PROBIHA CTENI Z FLASH
FLASHR	BSF	STATUS,RP1	; nasledujici blok programu
	BCF	STATUS,RP0	; propusti pouze adresy,
	MOVF	EEADRH,W		; ktere jsou v rozsahu 0003h - 1DFFh
	ANDLW	B'00011110'
	XORLW	B'00011110'
	BTFSC	STATUS,Z
	GOTO	RNULUJ		; mimo rozsah (horni mez)
	MOVF	EEADRH,W
	ANDLW	B'00011111'
	BTFSS	STATUS,Z
	GOTO	FLASHRJ00
	MOVLW	D'3'
	SUBWF	EEADR,W
	BTFSS	STATUS,C
	GOTO	RNULUJ		; mimo rozsah (horni mez)
	; ZAHAJUJE SE CTENI
FLASHRJ00	BSF	STATUS,RP0
	BSF	EECON1,EEPGD
	BSF	EECON1,RD
	NOP
	NOP
	BCF	STATUS,RP0
	BCF	STATUS,RP1
	RETURN
RNULUJ	CLRF	EEDATA
	CLRF	EEDATH
	BCF	STATUS,RP1
	RETURN

	; ZDE PROBIHA ZAPIS DO EEPROM
EEW	BSF	STATUS,RP1
	BSF	STATUS,RP0
	BCF	EECON1,EEPGD
	BSF	EECON1,WREN
	MOVLW	0x55
	MOVWF	EECON2
	MOVLW	0xAA
	MOVWF	EECON2
	BSF	EECON1,WR
	BCF	EECON1,WREN
	BTFSC	EECON1,WR
	GOTO	$-1
	BCF	STATUS,RP0
	BCF	STATUS,RP1
	RETURN

	; ZDE PROBIHA CTENI Z EEPROM
EER	BSF	STATUS,RP0
	BSF	STATUS,RP1
	BCF	EECON1,EEPGD
	BSF	EECON1,RD
	BCF	STATUS,RP1
	BCF	STATUS,RP0
	RETURN

	; ZDE DOCHAZI K UKONCOVANI ZAVADECE (ZAHLAZENI STOP)
ZAV_KONEC	BCF	STATUS,RP1
	BSF	STATUS,RP0
	CLRF	SPBRG		; resetovani pouzitych registru
	MOVLW	B'11111111'
	MOVWF	OPTION_REG
	MOVLW	B'00000010'
	MOVWF	TXSTA
	BCF	STATUS,RP0
	CLRF	RCSTA
	CLRF	T1CON
	CLRF	TMR1L
	CLRF	TMR1H
	CLRF	TMR0
	CLRF	INTCON
	CLRF	PIR1
	CLRF	PCLATH		; navrat na adresu 0003h
	GOTO	MAIN		; a konec zavadece
	
	END
