; poznamka - symbol (*) znaci, ze velicina je pouze adresou promenne

KEY_INIT	MACRO	IREGISTR, EIBIT, IBIT, PORTX, KB, K_OUT, KROK, K_STATUS, K_CAS1
; inicializace klavesnice
; IREGISTR - adresa registru, ktery obsahuje priznak nebo povoleni preruseni
;            pro zvoleny casovac
; EIBIT - bit v IREGISTRu, ktery povoluje preruceni od casovace
; IBIT - bit v IREGISTRu, ktery indikuje preruseni
; PORTX - adresa 8pinoveho portu, ke kteremu je pripojena klavesnice
; KB* - 2bytova pomocna promenna
; K_OUT* - 2bytova vystupni promenna
; KROK* - pomocna promenna
; K_STATUS* - promenna, ktera obsahuje stav obsluhy
;              (bit 0 rika, zda doslo ke zmene stavu klavesnice)
; K_CAS1* - promenna specialniho casovace (viz. odstranovani zakmitu)


	banksel	D'128'
	BSF	IREGISTR,EIBIT	; povoleni preruseni od casovace
	MOVLW	B'11101111'	; nastaveni TRIS registru pro PORTX (take banka 1)
	MOVWF	PORTX
	banksel	0
	MOVLW	B'00000000'	; nastaveni PORT registru (na nulovy potencial)
	MOVWF	PORTX
	CLRF	KB+1		; vynulovani pomocnych promennych
	CLRF	KB
	CLRF	K_OUT+1
	CLRF	K_OUT
	CLRF	KROK
	CLRF	K_STATUS
	CLRF	K_CAS1
	BCF	IREGISTR, IBIT	; vynulovani priznaku od casovace

	ENDM

KEY_IPROG	MACRO	IREGISTR, IBIT, PORTX, KB, K_OUT, KROK, XTEMP, K_STATUS, K_CAS1, T_STABIL
; obsluha klavesnice (pro system preruseni)
; IREGISTR - adresa registru, ktery obsahuje priznak preruseni
;            pro zvoleny casovac
; IBIT - bit v IREGISTRu, ktery indikuje preruseni
; PORTX - adresa 8pinoveho portu, ke kteremu je pripojena klavesnice
; KB* - 2bytova pomocna promenna
; K_OUT* - 2bytova vystupni promenna
; KROK* - pomocna promenna
; XTEMP* - pomocna promenna
; K_STATUS* - promenna, ktera obsahuje stav obsluhy
;              (bit 0 rika, zda doslo ke zmene stavu klavesnice)
; K_CAS1* - promenna specialniho casovace (viz. odstranovani zakmitu)
; T_STABIL - nutny pocet cyklu casovace K_CAS1, pro dozneni zakmitu


	LOCAL	KONEC, K_START, K_ZMENA, K_UKONCI

	banksel	IREGISTR
	BTFSS	IREGISTR,IBIT
	GOTO	KONEC
	BCF	IREGISTR,IBIT
	MOVF	K_CAS1,F	; pokud je K_CAS1 nulovy, muzeme pokracovat
	BTFSC	STATUS,Z
	GOTO	K_START
	DECF	K_CAS1,F	; ...pokud neni nulovy, dekrementujeme jej a koncime obsluhu
	GOTO	KONEC
K_START	MOVF	PORTX,W	; zde se multiplexne zjistuje stav klavecnice (viz. minuly program)
	ANDLW	B'00001111'
	BTFSC	KROK,0
	SWAPF	PORTX,W
	BTFSC	KROK,0
	ANDLW	B'11110000'
	BTFSS	KROK,1
	IORWF	KB,F
	BTFSC	KROK,1
	IORWF	KB+1,F

	INCF	KROK,F
	MOVLW	B'11101111'
	MOVWF	XTEMP
	BSF	STATUS,C
	BTFSC	KROK,0
	RLF	XTEMP,F
	BTFSC	KROK,1
	RLF	XTEMP,F
	BTFSC	KROK,1
	RLF	XTEMP,F
	MOVF	XTEMP,W
	IORLW	B'00001111'
	BSF	STATUS,RP0
	MOVWF	PORTX
	BCF	STATUS,RP0
	
	MOVF	KROK,W
	ANDLW	B'00000011'
	BTFSS	STATUS,Z
	GOTO	KONEC
	
	MOVF	KB,W	; porovname aktualni stav s minulym (K_OUT)
	XORWF	K_OUT,W
	BTFSS	STATUS,Z	; pokud jsou ruzne, doslo ke zmene
	GOTO	K_ZMENA
	MOVF	KB+1,W	; ..totez pro vyssi byte
	XORWF	K_OUT+1,W
	BTFSC	STATUS,Z
	GOTO	K_UKONCI	; pokud jsou K_OUT a KB shodne, regularne ukoncime obsluhu
K_ZMENA	BSF	K_STATUS,0	; pokud doslo ke zmene,
	MOVLW	T_STABIL	; nastavime casovani proti zakmitum
	MOVWF	K_CAS1	
	MOVF	KB,W	; ... a prepiseme stary stav novym stavem
	MOVWF	K_OUT
	MOVF	KB+1,W
	MOVWF	K_OUT+1
K_UKONCI	CLRF	KB	; KB se musi pro pristi cyklus vynulovat
	CLRF	KB+1
	
KONEC
	ENDM
