; poznamka - symbol (*) znaci, ze velicina je pouze adresou promenne

KEY_INIT	MACRO	IREGISTR, EIBIT, IBIT, PORTX, KB, K_OUT, KROK, K_STATUS, K_CAS1, S_KLAV
; inicializace klavesnice
; IREGISTR - adresa registru, ktery obsahuje priznak nebo povoleni preruseni
;            pro zvoleny casovac
; EIBIT - bit v IREGISTRu, ktery povoluje preruceni od casovace
; IBIT - bit v IREGISTRu, ktery indikuje preruseni
; PORTX - adresa 8pinoveho portu, ke kteremu je pripojena klavesnice
; KB* - 2bytova pomocna promenna
; K_OUT* - 2bytova vystupni promenna
; KROK* - pomocna promenna
; K_STATUS* - promenna, ktera obsahuje stav obsluhy
;              (bit 0 rika, zda doslo ke zmene stavu klavesnice)
; S_KLAV* - minuly stav klavesnice
; K_CAS1* - promenna specialniho casovace (viz. odstranovani zakmitu)

	banksel	D'128'
	BSF	IREGISTR,EIBIT	; povoleni preruseni od casovace
	MOVLW	B'11101111'	; nastaveni TRIS registru pro PORTX (take banka 1)
	MOVWF	PORTX
	banksel	0
	MOVLW	B'00000000'	; nastaveni PORT registru (na nulovy potencial)
	MOVWF	PORTX
	CLRF	KB+1		; vynulovani pomocnych promennych
	CLRF	KB
	CLRF	K_OUT+1
	CLRF	K_OUT
	CLRF	KROK
	CLRF	K_STATUS
	CLRF	K_CAS1
	CLRF	S_KLAV
	BCF	IREGISTR, IBIT	; vynulovani priznaku od casovace

	ENDM



KEY_IPROG	MACRO	IREGISTR, IBIT, PORTX, KB, K_OUT, KROK, XTEMP, K_STATUS, S_KLAV, K_CAS1, T_STABIL
; obsluha klavesnice (pro system preruseni)
; IREGISTR - adresa registru, ktery obsahuje priznak preruseni
;            pro zvoleny casovac
; IBIT - bit v IREGISTRu, ktery indikuje preruseni
; PORTX - adresa 8pinoveho portu, ke kteremu je pripojena klavesnice
; KB* - 2bytova pomocna promenna
; K_OUT* - 2bytova vystupni promenna
; KROK* - pomocna promenna
; XTEMP* - pomocna promenna
; K_STATUS* - promenna, ktera obsahuje stav obsluhy
;              (bit 0 rika, zda doslo ke zmene stavu klavesnice,
;	      bit 1 rika, zda doslo ke zmene z 1 na 0)
; S_KLAV* - minuly stav klavesnice
; K_CAS1* - promenna specialniho casovace (viz. odstranovani zakmitu)
; T_STABIL - nutny pocet cyklu casovace K_CAS1, pro dozneni zakmitu

	LOCAL	KONEC, K_START, K_ZMENA, K_UKONCI

	banksel	IREGISTR		; stejne, jako v minule verzi...
	BTFSS	IREGISTR,IBIT
	GOTO	KONEC
	BCF	IREGISTR,IBIT
	MOVF	K_CAS1,F
	BTFSC	STATUS,Z
	GOTO	K_START
	DECF	K_CAS1,F
	GOTO	KONEC
K_START	MOVF	PORTX,W
	ANDLW	B'00001111'
	BTFSC	KROK,0
	SWAPF	PORTX,W
	BTFSC	KROK,0
	ANDLW	B'11110000'
	BTFSS	KROK,1
	IORWF	KB,F
	BTFSC	KROK,1
	IORWF	KB+1,F

	INCF	KROK,F
	MOVLW	B'11101111'
	MOVWF	XTEMP
	BSF	STATUS,C
	BTFSC	KROK,0
	RLF	XTEMP,F
	BTFSC	KROK,1
	RLF	XTEMP,F
	BTFSC	KROK,1
	RLF	XTEMP,F
	MOVF	XTEMP,W
	IORLW	B'00001111'
	BSF	STATUS,RP0
	MOVWF	PORTX
	BCF	STATUS,RP0
	
	MOVF	KROK,W
	ANDLW	B'00000011'
	BTFSS	STATUS,Z
	GOTO	KONEC
	
	MOVF	KB,W	; stejne jako v minule verzi,
	XORWF	S_KLAV,W	; ale misto K_OUT je pouzit S_KLAV
	BTFSS	STATUS,Z
	GOTO	K_ZMENA
	MOVF	KB+1,W
	XORWF	S_KLAV+1,W
	BTFSC	STATUS,Z
	GOTO	K_UKONCI
K_ZMENA	BSF	K_STATUS,0	; indikace zmeny
	MOVLW	T_STABIL	; prodleva proti zakmitum
	MOVWF	K_CAS1
	MOVF	KB,W	; nyni se zjistuje, zda nekde doslo ke zmene z 1 do 0.
	XORWF	S_KLAV,W
	ANDWF	S_KLAV,W
	BTFSS	STATUS,Z
	BSF	K_STATUS,1	; pokud ano, indikujeme tuto "spadovou" zmenu
	IORWF	K_OUT,F	; ... a informaci pridame do K_OUT
	MOVF	KB+1,W	; totez provedeme i s vyssim bytem klavesnice
	XORWF	S_KLAV+1,W
	ANDWF	S_KLAV+1,W
	BTFSS	STATUS,Z
	BSF	K_STATUS,1
	IORWF	K_OUT+1,F

	MOVF	KB,W	; minuly stav prepiseme aktualnim
	MOVWF	S_KLAV
	MOVF	KB+1,W
	MOVWF	S_KLAV+1

K_UKONCI	CLRF	KB
	CLRF	KB+1
	
KONEC
	ENDM
