; poznamka - symbol (*) znaci, ze velicina je pouze adresou promenne

KEY_INIT	MACRO	IREGISTR, EIBIT, IBIT, PORTX, KB, K_OUT, KROK, K_STATUS, K_CAS1, S_KLAV
; inicializace klavesnice
; IREGISTR - adresa registru, ktery obsahuje priznak nebo povoleni preruseni
;            pro zvoleny casovac
; EIBIT - bit v IREGISTRu, ktery povoluje preruceni od casovace
; IBIT - bit v IREGISTRu, ktery indikuje preruseni
; PORTX - adresa 8pinoveho portu, ke kteremu je pripojena klavesnice
; KB* - 2bytova pomocna promenna
; K_OUT* - 2bytova vystupni promenna
; KROK* - pomocna promenna
; K_STATUS* - promenna, ktera obsahuje stav obsluhy
;              (bit 0 rika, zda doslo ke zmene stavu klavesnice)
; S_KLAV* - minuly stav klavesnice
; K_CAS1* - promenna specialniho casovace (viz. odstranovani zakmitu)

	banksel	D'128'
	BSF	IREGISTR,EIBIT	; povoleni preruseni od casovace
	MOVLW	B'11101111'	; nastaveni TRIS registru pro PORTX (take banka 1)
	MOVWF	PORTX
	banksel	0
	MOVLW	B'00000000'	; nastaveni PORT registru (na nulovy potencial)
	MOVWF	PORTX
	CLRF	KB+1		; vynulovani pomocnych promennych
	CLRF	KB
	CLRF	K_OUT+1
	CLRF	K_OUT
	CLRF	KROK
	CLRF	K_STATUS
	CLRF	K_CAS1
	CLRF	S_KLAV
	BCF	IREGISTR, IBIT	; vynulovani priznaku od casovace

	ENDM


KEY_IPROG	MACRO	IREGISTR, IBIT, PORTX, KB, KB2, KBCITAC, K_OUT, KROK, XTEMP, K_STATUS, S_KLAV, K_CAS1, T_STABIL
; obsluha klavesnice (pro system preruseni)
; IREGISTR - adresa registru, ktery obsahuje priznak preruseni
;            pro zvoleny casovac
; IBIT - bit v IREGISTRu, ktery indikuje preruseni
; PORTX - adresa 8pinoveho portu, ke kteremu je pripojena klavesnice
; KB* - 2bytova pomocna promenna
; KB2* - 4bytova pomocna promenna
; KBCITAC - pomocna promenna
; K_OUT* - 2bytova vystupni promenna
; KROK* - pomocna promenna
; XTEMP* - pomocna promenna
; K_STATUS* - promenna, ktera obsahuje stav obsluhy
;	     (bit 0 indikuje, zda doslo ke zmene stavu klavesnice,
;	      bit 1 indikuje, zda doslo ke zmene z 1 na 0,
;	      bit 2 indikuje, zda doslo k pretizeni klavesnice (dekce "L"))
; S_KLAV* - minuly stav klavesnice
; K_CAS1* - promenna specialniho casovace (viz. odstranovani zakmitu)
; T_STABIL - nutny pocet cyklu casovace K_CAS1, pro dozneni zakmitu

	LOCAL	KONEC, K_START, K_ZMENA, K_CHYBA, K_UKONCI
	LOCAL	K_NEXT1, K_NEXT2 ,K_NEXT3 ,K_NEXT4 ,K_NEXT5, L_TEST

	banksel	IREGISTR		; toto je stejne, jako u predchozi verze
	BTFSS	IREGISTR,IBIT
	GOTO	KONEC
	BCF	IREGISTR,IBIT
	MOVF	K_CAS1,F
	BTFSC	STATUS,Z
	GOTO	K_START
	DECF	K_CAS1,F
	GOTO	KONEC
K_START	MOVF	PORTX,W
	ANDLW	B'00001111'
	BTFSC	KROK,0
	SWAPF	PORTX,W
	BTFSC	KROK,0
	ANDLW	B'11110000'
	BTFSS	KROK,1
	IORWF	KB,F
	BTFSC	KROK,1
	IORWF	KB+1,F

	INCF	KROK,F
	MOVLW	B'11101111'
	MOVWF	XTEMP
	BSF	STATUS,C
	BTFSC	KROK,0
	RLF	XTEMP,F
	BTFSC	KROK,1
	RLF	XTEMP,F
	BTFSC	KROK,1
	RLF	XTEMP,F
	MOVF	XTEMP,W
	IORLW	B'00001111'
	BSF	STATUS,RP0
	MOVWF	PORTX
	BCF	STATUS,RP0
	
	MOVF	KROK,W
	ANDLW	B'00000011'
	BTFSS	STATUS,Z
	GOTO	KONEC
	
	MOVF	KB,W
	XORWF	S_KLAV,W
	BTFSS	STATUS,Z
	GOTO	K_ZMENA
	MOVF	KB+1,W
	XORWF	S_KLAV+1,W
	BTFSC	STATUS,Z
	GOTO	K_UKONCI
K_ZMENA	BSF	K_STATUS,0
	MOVLW	T_STABIL
	MOVWF	K_CAS1

	MOVF	KB,W	; zde se pripravuje promenna KB2 (4 byty)
	XORLW	B'11111111' ; musi byt inverzni ke KB (1 znamena, ze klavesa je stisknuta)
	ANDLW	B'00001111' ; u kazdeho bytu jsou pouzity jen 4 bity
	MOVWF	KB2	
	SWAPF	KB,W
	XORLW	B'11111111'
	ANDLW	B'00001111'
	MOVWF	KB2+1
	MOVF	KB+1,W
	XORLW	B'11111111'
	ANDLW	B'00001111'
	MOVWF	KB2+2	
	SWAPF	KB+1,W
	XORLW	B'11111111'
	ANDLW	B'00001111'
	MOVWF	KB2+3

	MOVF	KB2+0,W	; nyni probiha rutina, ktera zjistuje vyskyt kombinace "do L"
	IORWF	KB2+1,W
	IORWF	KB2+2,W
	ANDWF	KB2+3,W	; ta musi probehnou pro kazdy byte z KB2 zvlast
	BTFSC	STATUS,Z
	GOTO	K_NEXT1
	MOVF	KB2+3,W
	CALL	L_TEST	; pripadne je nutno pokazde kontrolovat pocet bitu v promenne
	BTFSS	STATUS,Z
	GOTO	K_CHYBA	; pokud je detekovano "L", musi to byt chapano jako chyba
K_NEXT1	MOVF	KB2+1,W	; totez pro druhy byte z KB2
	IORWF	KB2+2,W
	IORWF	KB2+3,W
	ANDWF	KB2+0,W
	BTFSC	STATUS,Z
	GOTO	K_NEXT2
	MOVF	KB2+0,W
	CALL	L_TEST
	BTFSS	STATUS,Z
	GOTO	K_CHYBA
K_NEXT2	MOVF	KB2+2,W	; ... pro treti byte z KB2
	IORWF	KB2+3,W
	IORWF	KB2+0,W
	ANDWF	KB2+1,W
	BTFSC	STATUS,Z
	GOTO	K_NEXT3
	MOVF	KB2+1,W
	CALL	L_TEST
	BTFSS	STATUS,Z
	GOTO	K_CHYBA
K_NEXT3	MOVF	KB2+3,W	; ... pro ctvrty byte z KB2
	IORWF	KB2+0,W
	IORWF	KB2+1,W
	ANDWF	KB2+2,W
	BTFSC	STATUS,Z
	GOTO	K_NEXT4
	MOVF	KB2+2,W
	CALL	L_TEST
	BTFSS	STATUS,Z
	GOTO	K_CHYBA

K_NEXT4	MOVF	KB,W	; dale program pokracuje jako v minule verzi
	XORWF	S_KLAV,W
	ANDWF	S_KLAV,W
	BTFSS	STATUS,Z
	BSF	K_STATUS,1
	IORWF	K_OUT,F
	MOVF	KB+1,W
	XORWF	S_KLAV+1,W
	ANDWF	S_KLAV+1,W
	BTFSS	STATUS,Z
	BSF	K_STATUS,1
	IORWF	K_OUT+1,F

K_NEXT5	MOVF	KB,W
	MOVWF	S_KLAV
	MOVF	KB+1,W
	MOVWF	S_KLAV+1
	GOTO	K_UKONCI

L_TEST	CLRF	KBCITAC	; tento podprogram testuje,
	MOVWF	XTEMP	; zda je pocet bitu v registru W vetsi nez jedna
	RRF	XTEMP,F	; ...pokud ano, bylo nalezeno "L"
	BTFSC	STATUS,C
	INCF	KBCITAC,F
	RRF	XTEMP,F
	BTFSC	STATUS,C
	INCF	KBCITAC,F
	RRF	XTEMP,F
	BTFSC	STATUS,C
	INCF	KBCITAC,F
	RRF	XTEMP,F
	BTFSC	STATUS,C
	INCF	KBCITAC,F
	DECF	KBCITAC,F
	RETURN

K_CHYBA	BSF	K_STATUS,2	; indikace chyby
	GOTO	K_NEXT5	; regularni ukonceni obsluhy

K_UKONCI	CLRF	KB
	CLRF	KB+1
	
KONEC
	ENDM
