	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	znaky.inc
	#include	displej.inc
	#include	key_sys.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

#DEFINE	DB4	PORTE,2		; PINY PRO OVLADANI DISPLEJE
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

TXBSIZE	EQU	16
RCBSIZE	EQU	16

OFFRAM	EQU	H'20'		; ZACATEK VOLNE PAMETI "RAM"
TEMPRAM	EQU	H'70'

	CBLOCK	OFFRAM
	TMH:1
	TML:1
	DDATA:1

	KB:2
	KB2:4
	KBCITAC:1
	K_OUT:2
	KROK:1
	KEYTEMP:1
	K_STATUS:1
	S_KLAV:2
	K_CAS1:1
	K_CAS2:2

	KEY:2
	CITAC:1

	ZNAKPOS:1
	ENDC
	
	CBLOCK	TEMPRAM
	W_TEMP:1
	ST_TEMP:1
	FSR_TEMP:1
	ENDC

	ORG	0
	NOP
	NOP
	NOP
	GOTO	START

	ORG	4
	MOVWF	W_TEMP
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP

	KEY_IPROG	INTCON, T0IF, PORTD, KB, KB2, KBCITAC, K_OUT, KROK, KEYTEMP, K_STATUS, S_KLAV, K_CAS1, K_CAS2, D'25', D'50', D'5', B'00001111'

	MOVF	FSR_TEMP,W
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

START	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'64'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 19200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA jako "logicky"
	MOVWF	ADCON1
	banksel	0

	banksel	OPTION_REG
	MOVLW	B'00000001'
	MOVWF	OPTION_REG
	banksel	0

	KEY_INIT	INTCON, T0IE, T0IF, PORTD, KB, K_OUT, KROK, K_STATUS, K_CAS1, K_CAS2, S_KLAV

	CALL	INITDISP

	MOVLW	D'3'	; napis na displeji
	CALL	SETPOS
	MOVLW	ZNAK_K
	CALL	PUTZNAK
	MOVLW	ZNAK_L
	CALL	PUTZNAK
	MOVLW	ZNAK_A
	CALL	PUTZNAK
	MOVLW	ZNAK_V
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_S
	CALL	PUTZNAK
	MOVLW	ZNAK_N
	CALL	PUTZNAK
	MOVLW	ZNAK_I
	CALL	PUTZNAK
	MOVLW	ZNAK_C
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_DVTC
	CALL	PUTZNAK

	MOVLW	D'64'+2
	CALL	SETPOS
	MOVLW	ZNAK_K
	CALL	PUTZNAK
	MOVLW	ZNAK_O
	CALL	PUTZNAK
	MOVLW	ZNAK_N
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK
	MOVLW	ZNAK_C
	CALL	PUTZNAK
	MOVLW	ZNAK_N
	CALL	PUTZNAK
	MOVLW	ZNAK_A
	CALL	PUTZNAK
	MOVLW	ZNAK_SP
	CALL	PUTZNAK
	MOVLW	ZNAK_F
	CALL	PUTZNAK
	MOVLW	ZNAK_A
	CALL	PUTZNAK
	MOVLW	ZNAK_Z
	CALL	PUTZNAK
	MOVLW	ZNAK_E
	CALL	PUTZNAK

	BSF	INTCON,PEIE
	BSF	INTCON,GIE

	CLRF	CITAC	; pro inicializaci podprogramu GETKEY
	MOVLW	D'0'
	CALL	SETPOS	; nastaveni pocatecni pozice na displeji
	CLRF	ZNAKPOS
	MOVLW	B'00000100' ; nastaveni PCLATH pro potreby aktivni tabulky "VYBER"
	MOVWF	PCLATH
LOOP	CALL	READKEY	; cekani na stisk nektere klavesy
LOOP2	CALL	GETKEY	; zjistovani kodu klavesy	
	BTFSC	STATUS,Z	; pokud jiz neni nalezena zadna klavesa,
	GOTO	LOOP	; jdi na navesti LOOP (cekani na novy stisk klavesy)
	CALL	VYBER	; podle cisla klavesy vyber patricny symbol displeje
	CALL	PUTZNAK	; zobraz tento symbol
	CALL	ZVYSPOS	; posun kurzor displeje na dalsi znak (cyklicky a dvouradkove!)
	GOTO	LOOP2	; vrat se a hledej dalsi kod klavesy
	
READKEY	READKEY_	K_STATUS, K_OUT, KEY
	RETURN

GETKEY	GETKEY_	KEY,CITAC
	RETURN

	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

ZVYSPOS	INCF	ZNAKPOS,F
	MOVF	ZNAKPOS,W
	XORLW	D'16'
	MOVLW	D'64'
	BTFSC	STATUS,Z
	MOVWF	ZNAKPOS
	MOVF	ZNAKPOS,W
	XORLW	D'64' + D'16'
	MOVLW	D'0'
	BTFSC	STATUS,Z
	MOVWF	ZNAKPOS
	MOVF	ZNAKPOS,W
	CALL	SETPOS
	RETURN

	ORG	D'1024'
VYBER	ADDWF	PCL,F
	RETLW	D'0'
	RETLW	ZNAK_2
	RETLW	ZNAK_5
	RETLW	ZNAK_8
	RETLW	ZNAK_0
	RETLW	ZNAK_1
	RETLW	ZNAK_4
	RETLW	ZNAK_7
	RETLW	ZNAK_HVZD
	RETLW	ZNAK_A
	RETLW	ZNAK_B
	RETLW	ZNAK_C
	RETLW	ZNAK_D
	RETLW	ZNAK_3
	RETLW	ZNAK_6
	RETLW	ZNAK_9
	RETLW	ZNAK_MRIZ
	
	END
